#include "BinaryTree.h"
#include <stack>

void print(std::ostream& os, BinaryTree::Node* curr) {
	//preorder -> curr,left,right
	os << curr->val << " ";
	//obradi levo
	if (curr->left != nullptr) print(os, curr->left);
	//obradi desno
	if (curr->right != nullptr) print(os, curr->right);
}

void deleteTree(BinaryTree::Node* curr) {
	//postorder -> left,right,curr
	//obradi levo
	if (curr->left != nullptr) deleteTree( curr->left);
	//obradi desno
	if (curr->right != nullptr) deleteTree( curr->right);

	delete curr;
}

//void print2(std::ostream& os, BinaryTree::Node* curr) {
//	
//	std::stack<BinaryTree::Node*> stack;
//
//	stack.push();
//}

std::ostream& operator<<(std::ostream& os, const BinaryTree& t) {
	if (t.root != nullptr) print(os, t.root);
	return os;
}



int main() {
	BinaryTree t;

	t.insert(15);
	t.insert(11);
	t.insert(8);
	t.insert(6);
	t.insert(9);
	t.insert(12);
	t.insert(14);

	t.insert(26);
	t.insert(20);
	t.insert(21);
	t.insert(30);
	t.insert(35);

	std::cout << t << std::endl;


}
