#pragma once
#include <iostream>
class BinaryTree
{

private:
	struct Node {
		Node* left, * right;
		int val;
		Node(int val): val(val), left(nullptr), right(nullptr) {}
	};

	Node* root;

	friend void print(std::ostream& os, BinaryTree::Node* curr);

	friend void deleteTree(BinaryTree::Node* curr);

public:

	BinaryTree() :root(nullptr) {

	}

	virtual ~BinaryTree() {
		deleteTree(root);
	}

	bool insert(int val) {
		if (root == nullptr) {
			root = new Node(val);
			return true;
		}
		Node* curr = root;
		while (curr != nullptr) {
			if (val < curr->val) {
				if (curr->left) curr = curr->left;
				else {
					curr->left = new Node(val);
					return true;
				}
			}
			else if (val > curr->val) {
				if (curr->right) curr = curr->right;
				else {
					curr->right = new Node(val);
					return true;
				}
			}
			else return false;
		}
	}

	bool find(int val) {
		Node* curr = root;
		while (curr != nullptr) {
			if (val < curr->val) {
				if (curr->left) curr = curr->left;
			}
			else if (val > curr->val) {
				if (curr->right) curr = curr->right;
			}
			else return true;
		}
		return false;
	}

	
	friend std::ostream& operator<<(std::ostream&, const BinaryTree&);
};

