#include "BinaryTree.h"
#include <stack>


template <typename T>
void print(std::ostream& os, typename BinaryTree<T>::Node* curr) {
	//preorder -> curr,left,right
	os << *(curr->p) << " ";
	//obradi levo
	if (curr->left != nullptr) print<T>(os, curr->left);
	//obradi desno
	if (curr->right != nullptr) print<T>(os, curr->right);
}

template <typename T>
void deleteTree(typename BinaryTree<T>::Node* curr) {
	//postorder -> left,right,curr
	//obradi levo
	if (curr->left != nullptr) deleteTree<T>( curr->left);
	//obradi desno
	if (curr->right != nullptr) deleteTree<T>( curr->right);

	delete curr;
}

template <typename T>
BinaryTree<T>::~BinaryTree() {
	deleteTree<T>(root);
}
//void print2(std::ostream& os, BinaryTree::Node* curr) {
//	
//	std::stack<BinaryTree::Node*> stack;
//
//	stack.push();
//}
template <typename T>
std::ostream& operator<<(std::ostream& os, const BinaryTree<T>& t) {
	if (t.root != nullptr) print<T>(os, t.root);
	return os;
}

template <typename T>
bool BinaryTree<T>::insert(const T& val) {
	if (root == nullptr) {
		root = new Node(val);
		return true;
	}
	Node* curr = root;
	while (curr != nullptr) {
		if (val < *(curr->p)) {
			if (curr->left) curr = curr->left;
			else {
				curr->left = new Node(val);
				return true;
			}
		}
		else if (val > *(curr->p)) {
			if (curr->right) curr = curr->right;
			else {
				curr->right = new Node(val);
				return true;
			}
		}
		else return false;
	}
}

template <typename T>
bool BinaryTree<T>::find(const T& val) const {
	Node* curr = root;
	while (curr != nullptr) {
		if (val < *(curr->p)) {
			if (curr->left) curr = curr->left;
		}
		else if (val > *(curr->p)) {
			if (curr->right) curr = curr->right;
		}
		else return true;
	}
	return false;
}



int main() {
	BinaryTree<int> t;

	t.insert(15);

	t.insert(11);
	t.insert(8);
	t.insert(6);
	t.insert(9);
	t.insert(12);
	t.insert(14);

	t.insert(26);
	t.insert(20);
	t.insert(21);
	t.insert(30);
	t.insert(35);

	std::cout << t << std::endl;


}
