#pragma once
#include <iostream>


template <typename T>
class BinaryTree {
	
	
	struct Node {
		Node* left, * right;
		const T* p;
		Node(const T& val): p(&val), left(nullptr), right(nullptr) {}
	};
	

	Node* root;

	template <typename T>
	friend void print(std::ostream& os,typename BinaryTree<T>::Node* curr);

	template <typename T>
	friend void deleteTree(typename BinaryTree<T>::Node* curr);

public:

	BinaryTree() :root(nullptr) {}

	virtual ~BinaryTree();

	bool insert(const T&);

	bool find(const T&) const;

	template <typename T>
	friend std::ostream& operator<<(std::ostream&, const BinaryTree<T>&);
};

